# 
# If "?????????" then File - Reopen with Encoding... windows-1251
#
#   .. ,  
#     
#  .. 
#
#   "   "
# http://www.landscape.edu.ru/edu_help5_KiS.shtml
# /  4    "   ""
# http://www.landscape.edu.ru/edu_help4_R.shtml
# 
#  3. "    R. " 
# :   R   0: 
#       7    
#  : The Significant Earthquake Database https://www.ngdc.noaa.gov/nndc/struts/form?t=101650&s=1&d=1" target="_blank"
#
# ######################################################################
#   12.02.2020
# ######################################################################

setwd("C:/Users/Danilko/OneDrive/0_EDU/R/EarthQ") #   
data <- read.csv2("EarthQ_200212.txt", header = TRUE, sep = ";", dec = ".", fill = TRUE, 
                  stringsAsFactors = FALSE) #   "\t"
#     ,
#   -  ( ), 
#  () -  (Y),  (M)   (D) , 
#  (Xd, Yd)   (Place)  ,  (MM)
View(data) #  

#      [  -  ,  -  ]
data=na.omit(data[data$MM>=7 & data$Y>1900 & data$Y<2020 & data$Yd<=90 & data$Yd>=-90,]) # 

#   
library(maptools)                         #      
EQxy= na.omit(data)             #       
coordinates(EQxy) = ~Xd+Yd                #     
worldmap <- readShapePoly("worldmap")     #     shp-
par(mar=c(2, 2, 1.5, 0.2))  #      , 
plot(worldmap, axes=TRUE, border="gray")  #  
points(EQxy, pch=20, cex=0.8)             #     

#      
plot(as.factor(data$Y)) #     
#aggregate(data$Y, by=list(data$Y), FUN="length")   #    
summary(aggregate(data$Y, by=list(data$Y), FUN="length")$x)
# ..      8   >=7    2  18 /

plot(as.factor(data$M)) #       1900  2019 .
#aggregate(data$M, by=list(data$M), FUN="length")/119   #       119   1900  2019  
summary(aggregate(data$M, by=list(data$M), FUN="length")$x/116)
# ..          >=7
#    ,    ?

#       (1900-2019)      
aggdata = aggregate(data$D, by=list(data$Y,data$M), FUN="length")
head(aggdata)   #      ( -  ,   -  )
names(aggdata) = c("Y","M","EQ") #  
head(aggdata)   #      ( -  ,   -  )
attach(aggdata) #  aggdata    
library(gplots)
plotmeans(EQ~factor(M), xlab="", ylab="  ")
table(M)        #    1900-2019 .   
# ..       
#   -     
library(reshape)
temp <- cast(aggdata, Y~M, value="EQ", mean, fill=0)
View(temp) #  
detach(aggdata)

aggdata <- melt(temp)
head(aggdata)
names(aggdata) = c("Y","EQ","M")
head(aggdata)
attach(aggdata) #  aggdata    
plotmeans(EQ~factor(M), xlab="", ylab="  ")
table(M)
#     ,    

#  
heatmap(as.matrix(temp), Rowv = NA, Colv = NA)

#        
#     ,  -   (   )
oneway.test(EQ ~ M) #   
pairwise.t.test(EQ, M, p.adj="bonferroni") #    p-value ( )

#      ,    
t.test(rnorm(1000, mean = 0, sd = 1), rnorm(1000, mean = 0, sd = 1), conf.level = 0.95, paired=FALSE) #   
t.test(rnorm(1000, mean = 3, sd = 1), rnorm(1000, mean = 0, sd = 1), conf.level = 0.95, paired=FALSE) #   :

hist(EQ[M=="11"], breaks=10, main="", col = "lightblue", border = "darkgrey", labels = TRUE)
hist(EQ[M=="9"], breaks=10, main="", col = "lightblue", border = "darkgrey", labels = TRUE)

#   -   ( ):
kruskal.test(EQ ~ M)                                #    
kruskal.test(EQ[M=="11"] ~ EQ[M=="9"])              #    
pairwise.wilcox.test(EQ, M, p.adjust.method = "BH") #     

# :    0.95       ,   ...
#      ,   ,   

#     ?
aggdata[M=="11",]
#  1938  2004     5   M>=7
na.omit(data[data$M==11 & data$Y==1938 | data$Y==2004 & data$M==11, ])
detach(aggdata)

#     1950-2019 

###  ############################################################################

